class Sort {

  /// Sorts prefix of an array in ascending order.
  static void bubbleSort ( int a[], int size )
  {
    int i, j;
    for ( j = size-1; j > 0; j-- )  // a[0] to a[j] needs to be sorted
      for ( i = 0; i < j; i++ )     // test a[i] vs. a[i+1]
        if ( a[i] > a[i+1] ) {
          int tmp = a[i];
          a[i]    = a[i+1];
          a[i+1]  = tmp;
        }
  }

  /// main - sort test..
  public static void main ( String[] args )
  {
    int[] a = { 12, 0, 35, 7, 16, 144, 99, -3, -8, 2 };
    bubbleSort(a,a.length);
    int i;
    System.out.print("Sorted array:");
    for ( i = 0; i < a.length; i++ )
      System.out.print(" " + a[i]);
    System.out.println();
  }
  
}
