const int QSMin = 12;

void qs ( double *a, int len )
{
  int i, j;
  if ( len < QSMin ) {                 // short array => insert-sort
    while ( len > 1 ) {                // find minimum and swap it to a[0]
      double min = a[0];
      j = 0;
      for ( i = 1; i < len; i++ )
        if ( a[i] < min ) {
          min = a[i];
          j = i;
        }
      if ( j != 0 ) {
        a[j] = a[0];
        a[0] = min;
      }
      a++;
      len--;
    }
    return;
  }

    // the array is long enough for quick-sort:
  double pivot = (a[0] + a[len-1]) * 0.5;
  i = -1; j = len;
  do {
    do i++;
    while ( i < len && a[i] <= pivot );
    do j--;
    while ( j >= 0  && a[j] >= pivot );
    if ( j < i ) break;
    double tmp = a[i];
    a[i] = a[j];
    a[j] = tmp;
  } while ( true );

    // j < i => sort [0 to j] and [i to len-1]:
  if ( j + 1 < len - i ) {             // [0 to j] first
    if ( j > 0 ) qs(a,j+1);
    qs(a+i,len-i);
  }
  else {                               // [i to len-1] first
    if ( len-i > 1 ) qs(a+i,len-i);
    qs(a,j+1);
  }
}
