/**
 * Object which can be asked for Entity's position.
 */
interface Locator {

	/**
	 * Returns public (approximated) position of the entity (asker).
	 * @param  asker Entity asking for localization.
	 * @param  result Pre-allocated array to hold the result (optional, may be null).
	 * @return array holding two items: [x,y]
	 */
	int[] getPosition ( Entity asker, int[] result );

}
